# This is part of ypp-sc-tools, a set of third-party tools for assisting
# players of Yohoho Puzzle Pirates.
#
# Copyright (C) 2009 Ian Jackson <ijackson@chiark.greenend.org.uk>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Yohoho and Puzzle Pirates are probably trademarks of Three Rings and
# are used without permission.  This program is not endorsed or
# sponsored by Three Rings.

package CommodsDatabase;

use strict;
use warnings;

use DBI;

use Commods;

BEGIN {
    use Exporter ();
    our ($VERSION, @ISA, @EXPORT, @EXPORT_OK, %EXPORT_TAGS);
    $VERSION     = 1.00;
    @ISA         = qw(Exporter);
    @EXPORT      = qw(&db_setocean &db_connect $dbh
		      &db_filename &db_doall);
    %EXPORT_TAGS = ( );

    @EXPORT_OK   = qw();
}

our $dbfn;
our $dbh;

sub db_setocean ($) {
    my ($oceanname) = @_;
    $dbfn= "OCEAN-$oceanname.db";
}
sub db_filename () {
    return $dbfn;
}

sub db_connect () {
    $dbh= DBI->connect("dbi:SQLite:$dbfn",'','',
		       { AutoCommit=>0,
			 RaiseError=>1, ShowErrorStatement=>1,
			 unicode=>1 })
	or die "$dbfn $DBI::errstr ?";
}

sub db_doall ($) {
    foreach my $cmd (split /\;/, $_[0]) {
	$dbh->do("$cmd;") if $cmd =~ m/\S/;
    }
}

1;
